
import random,types,math


from graphic_ops import *


import warnings
warnings.filterwarnings("ignore","tempnam is a potential security risk to your program",RuntimeWarning)



# nice camcording carminebreakout010403/PICT1016_512kb.mp4

def generate(infile,outfile,
             random_seed=0,
             perspective_sigma=40.0,
             shake_radius=10.0,
             shake_period=20.0,
             gain_control_strength=0.8,
             gain_control_inertia=0.8,
             blur_radius=3.0,
             codec_verbose=False): 

  try:

    # prepare input and output

    src=FlexPlayer(infile,verbose_mplayer=codec_verbose)
    
    sink=VidEncoder(outfile,src.w,src.h,src.fps,verbose_mplayer=codec_verbose)

    # build filter chain

    filters=[]

    if random_seed!=None:  random.seed(random_seed)

    # perspective transform

    if perspective_sigma>0: 
      coords=[random.gauss(d,perspective_sigma) for y in (0,src.h) for x in (0,src.w) for d in (x,y)]

      if shake_radius>0 and shake_period>0:
        shake=Shake2D(shake_radius,shake_period)
        filters.append(PerspectiveWithShakeFilter(coords,shake))
      else:
        filters.append(PerspectiveFilter(coords))                 

    # gain control 
    
    filters.append(GainControl(strength=gain_control_strength, inertia=gain_control_inertia))

    # blur 

    if blur_radius>0:     
      filters.append(BlurFilter(blur_radius))

    # transform the video
    
    run_filter(src,filters,sink)

  except Exception,e:
    # need to take care of exceptions here as the GIMP plugin system
    # tends to hide stacktraces
    traceback.print_exc(50,sys.stdout)
    pdb.gimp_quit(0)
    sys.exit(1)


