#! /bin/bash


function usage () {
  cat >> /dev/stderr <<EOF

usage: $0 [-options options] -o outfile.mpg infile.mp4 

options is a list of name=value pairs separated by ','. Possible options are:

random_seed              (integer, default 0):     random seed used to generate the deformations
perspective_sigma        (float, default 40.0):    std. dev. of the corner displacement
shake_radius             (float, default 10.0):    how much shaking
shake_period             (float, default 20.0):    how long are the shakes
gain_control_strength    (float, default 0.8):     amount of gain control 
gain_control_inertia     (float, default 0.8):     inertia of gain control
blur_radius              (float, default 3.0):     amount of blurring
codec_verbose            (boolean, default False): make mencoder verbose

EOF
  exit
}


while [ $# -ne 0 ]; do 
  a=$1; shift
  case $a in 
  --help|-h) usage;;
  -options)  options="$options,$1"; shift;; 
  -o)        output="$1"; shift;;
  *)         input="$a";;  
  esac
done




gimp --console-messages --no-interface --batch-interpreter=python-fu-eval -b "

import sys

from gimpfu import *

sys.path+=['.']

try:
  import camcording
  camcording.generate('$input','$output' $options)
except ImportError,e:
  traceback.print_exc(50,sys.stderr)
  pdb.gimp_quit(0)
  sys.exit(1)

pdb.gimp_quit(0)
sys.exit(0)


"
